/*
 * NodeIcon.java
 *
 * Created on March 31, 2008, 11:25 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package medusa.example;

import java.awt.Color;
import java.awt.GradientPaint;
import java.awt.Graphics2D;
import java.awt.geom.Point2D;
import java.awt.image.BufferedImage;
import java.awt.image.ConvolveOp;
import java.awt.image.Kernel;

/**
 *
 * @author Sean
 */
public class NodeIcon{
    
    private Kernel myKernel;
    public ConvolveOp simpleBlur;
    float weight = 1.0f/9.0f;
    float[] elements = new float[9]; // create 2D array
    
    public NodeIcon(){
        for (int i = 0; i < 9; i++) {
            elements[i] = weight;
        }
        myKernel = new Kernel(3, 3, elements);
        simpleBlur = new ConvolveOp(myKernel);
    }
    
    public BufferedImage createGlossyButton(Color color,int size){
        BufferedImage image = new BufferedImage(size+1,
                size+1,BufferedImage.TYPE_INT_ARGB);
        BufferedImage tImage = new BufferedImage(size+1,
                size+1,BufferedImage.TYPE_INT_ARGB);
        Graphics2D g2D = image.createGraphics();
        
        g2D.setColor(color);
        g2D.fillOval(0,0,size,size);
        g2D.setColor(Color.white);
        g2D.fillOval(1,1,3,3);
        //simpleBlur.filter(image, tImage);
        return image;
    }
    

}
