/*
 * HCL.java
 *
 * Created on January 1, 2002, 1:27 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package medusa.georgios.ClusteringAlgorithms;


import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

/**
 *
 * @author Georgios
 */
public class HCL {
    static float[][] matrix;
    static ArrayList<String> labels;
    int INCREMENT;
    int x,y;
    ArrayList<Integer> Stored_Nodes_Map = new ArrayList();
    Node Tree;
    float Infinite = -9999999;
     
     
    /** Creates a new instance of HCL */
    public HCL(float[][] Matrix,ArrayList<String> labels ) {
        this.matrix=Matrix;
        this.labels=labels;
        
         for (int i = 0; i < Matrix.length; i++) {
            for (int j = i + 1; j < Matrix.length; j++) {
                Infinite = Math.max(Matrix[i][j], Infinite);
            }
        }Infinite++;
        //Infinite=Math.max(Infinite, 9999999);

        for (int i = 0; i < Matrix.length; i++) {
            for (int j = i + 1; j < Matrix.length; j++) {
                if (Matrix[i][j] == 0) 
                    Matrix[i][j]= Infinite;
                 Matrix[j][i]=Matrix[i][j] ;
            }
        }
        
        this.INCREMENT=labels.size();
       //  print_matrix();
        this.run_hierarchical_clustering();
        
    }
    
    
    
  void find_minimum()
{
    int i,j;
    
	float minimum=Infinite;
	for (i = 0; i < INCREMENT; i++)
        for (j = i+1; j < INCREMENT; j++) {
		  if(matrix[i][j]<=minimum)
		  {
                     minimum=matrix[i][j];
                     x=i;
                     y=j;
                  }
    }
        
      //  System.out.println("111111111111111111");
        
        for (i = 0; i <  this.INCREMENT; i++){
            matrix[x][i]=matrix[i][x]=Math.min(matrix[i][x],matrix[i][y]);
            if(matrix[x][i]==0) break;
        }
        for (i = 0; i <  this.INCREMENT; i++){
            matrix[y][i]=matrix[i][y]=Math.min(matrix[i][y],matrix[i][y]);
            if(matrix[y][i]==0) break;
        }
        
         for (j = 0; j <  this.INCREMENT; j++){
            matrix[j][x]=matrix[x][j]=Math.min(matrix[x][j],matrix[y][j]);
            if(matrix[j][x]==0) break;
         }
        for (j = 0; i <  this.INCREMENT; j++){
            matrix[y][j]=matrix[j][y]=Math.min(matrix[x][j],matrix[y][j]);
            if(matrix[y][j]==0) break;
        }
         
      
        
     //  System.out.println("2222222222222222\t"+ x+"\t"+y);
       matrix[x][y]=matrix[y][x]=Infinite;
   
  //  print_matrix();
}
  
   
  void print_matrix()
  {
      for (int i = 0; i < matrix.length; i++) {
          for (int j = 0; j < matrix.length; j++)
             if(i<=j)
             System.out.print(matrix[i][j]+"\t\t");
             else
                 System.out.print("\t\t");
          System.out.println("");
      }
  }
  
  
  
    void run_hierarchical_clustering()
{
        
   Tree = new Node(labels);     
   int i,counter=0, tree_nodes=INCREMENT;
   int roots_found=0; 
   Node node1,node2, source_parent,destination_parent1,destination_parent2;
 

   for(i=0;i<INCREMENT;i++)
      Tree.create_node();


while(counter<INCREMENT)
{

   find_minimum();


   if(!Stored_Nodes_Map.contains(x))
   { Stored_Nodes_Map.add(x); 
       counter++;}

   if(!Stored_Nodes_Map.contains(y))
   { Stored_Nodes_Map.add(y);
       counter++;}

	
   node1=Tree.Index_nodes_map.get(x);
   node2=Tree.Index_nodes_map.get(y);
  
   Tree.search_higher_ancestor_of(node2);
   destination_parent2=Tree.higher_parent;

   Tree.search_higher_ancestor_of(node1);
   destination_parent1=Tree.higher_parent;
   


  if( destination_parent1.id!=destination_parent2.id)
   {
	   source_parent=Tree.create_node();
          tree_nodes++;

   if(!Tree.connection_exists(source_parent,destination_parent1))
	 	Tree.connect(source_parent,destination_parent1);

   if(!Tree.connection_exists(source_parent,destination_parent2))
	  	Tree.connect(source_parent,destination_parent2);
   }


  // printf("\n ancestor of %d is %d\n", node1.id, destination_parent1.id);
  // printf("\n ancestor of %d is %d\n", node2.id, destination_parent2.id);  
  // printf("\t========== %d-%d", source_parent.id, destination_parent2.id);
   

//break;
}


  find_minimum();

   node1=Tree.Index_nodes_map.get(x);
   node2=Tree.Index_nodes_map.get(y);
   Tree.search_higher_ancestor_of(node2);
   destination_parent2=Tree.higher_parent;
   Tree.search_higher_ancestor_of(node1);
   destination_parent1=Tree.higher_parent;
   
  if( destination_parent1.id!=destination_parent2.id)
   {   source_parent=Tree.create_node();
       tree_nodes++;

   if(!Tree.connection_exists(source_parent,destination_parent1))
	  	Tree.connect(source_parent,destination_parent1);
   if(!Tree.connection_exists(source_parent,destination_parent2))
	 	Tree.connect(source_parent,destination_parent2);
   }
//
//
//
	   //Exception if the tree has more than one roots. 
	   //Then it should merge into a rooted tree
	   do{
	   roots_found=0;
	   for(i=0;i<Tree.id_counter;i++){
		node1=Tree.Index_nodes_map.get(i);
		if(node1.parent==null )
			roots_found++;
	   }
        if(roots_found!=1)
        {
          for(i=0;i<Tree.id_counter;i++){
		     node1=Tree.Index_nodes_map.get(i);
		  if(node1.parent==null )
			  break;
		  }
		  for(i=0;i<Tree.id_counter;i++){
		     node2=Tree.Index_nodes_map.get(i);
		  if(node2.parent==null && node2.id!=node1.id )
			  break;}

		  source_parent=Tree.create_node();
          tree_nodes++;
		  Tree.connect(source_parent,node1);
		  Tree.connect(source_parent,node2);
		}
	   }while(roots_found!=1);
	   

        



}
    
      public void Save_To_File(String filename, String information)
     { 
     try {
        BufferedWriter outp = new BufferedWriter(new FileWriter(filename));  
         outp.append(information);
        outp.close();
        } catch (IOException e) {}
     
     }  
      
public String get_NewickFormat_HCL()
{
    String str=Tree.get_tree_NewickFormat().toString().trim();
//     Save_To_File(MainPackage.GraphInformation.codebase+"HCL_clustering.txt",str);
    return str;
}
      
public String get_NewickFormat_HCL(String layer)
{
    String str=Tree.get_tree_NewickFormat().toString().trim();
   //  Save_To_File(MainPackage.GraphInformation.codebase+layer+" HCL_clustering.txt",str);
    return str;
}

    public static void main(String[] args) {
        
//        List2Graph gr = new List2Graph("test3.txt");
//        labels=gr.labels;
//        matrix=gr.A;
        
        
        
       labels = new ArrayList();
       labels.add("BA"); labels.add("FI"); labels.add("MI");
       labels.add("NA"); labels.add("RM"); labels.add("TO");
       matrix = new float[labels.size()][labels.size()];
        matrix[0][0]=0;   matrix[0][1]=662; matrix[0][2]=877; matrix[0][3]=255; matrix[0][4]=412; matrix[0][5]=996; 
        matrix[1][0]=662; matrix[1][1]=0;   matrix[1][2]=295; matrix[1][3]=468; matrix[1][4]=268; matrix[1][5]=400; 
        matrix[2][0]=877; matrix[2][1]=295; matrix[2][2]=0;   matrix[2][3]=754; matrix[2][4]=564; matrix[2][5]=138; 
        matrix[3][0]=255; matrix[3][1]=468; matrix[3][2]=754; matrix[3][3]=0;   matrix[3][4]=219; matrix[3][5]=869; 
        matrix[4][0]=412; matrix[4][1]=268; matrix[4][2]=564; matrix[4][3]=219; matrix[4][4]=0;   matrix[4][5]=669; 
        matrix[5][0]=996; matrix[5][1]=400; matrix[5][2]=138; matrix[5][3]=869; matrix[5][4]=669; matrix[5][5]=0; 

        
        
        
//                
//       labels = new ArrayList();
//       labels.add("A"); labels.add("B"); labels.add("C");
//       labels.add("D"); labels.add("E"); labels.add("F");
//        matrix = new float[labels.size()][labels.size()];
//        matrix[0][0]=0;   matrix[0][1]=1; matrix[0][2]=0; matrix[0][3]=0; matrix[0][4]=0; matrix[0][5]=2.1f; 
//        matrix[1][0]=1; matrix[1][1]=0;   matrix[1][2]=0; matrix[1][3]=0; matrix[1][4]=0; matrix[1][5]=0; 
//        matrix[2][0]=0; matrix[2][1]=0; matrix[2][2]=0;   matrix[2][3]=2; matrix[2][4]=3; matrix[2][5]=0; 
//        matrix[3][0]=0; matrix[3][1]=0; matrix[3][2]=0; matrix[3][3]=0;   matrix[3][4]=0; matrix[3][5]=0; 
//        matrix[4][0]=0f; matrix[4][1]=0; matrix[4][2]=0; matrix[4][3]=0; matrix[4][4]=0;   matrix[4][5]=0; 
//        matrix[5][0]=0; matrix[5][1]=0; matrix[5][2]=0; matrix[5][3]=0; matrix[5][4]=0; matrix[5][5]=0; 

        
//            labels = new ArrayList();
//       labels.add("BOS"); labels.add("NY"); labels.add("DC");
//       labels.add("MIA"); labels.add("CHI"); labels.add("SEA");
//       labels.add("SF"); labels.add("LA"); labels.add("DEN");
//       
//        matrix = new float[labels.size()][labels.size()];
//        matrix[0][0]=0;   matrix[0][1]=206; matrix[0][2]=429; matrix[0][3]=1504; matrix[0][4]=963; matrix[0][5]=2976;  matrix[0][6]=3095;     matrix[0][7]=2979;   matrix[0][8]=1949; 
//        matrix[1][0]=1; matrix[1][1]=0;   matrix[1][2]=233; matrix[1][3]=1308; matrix[1][4]=802; matrix[1][5]=2815;   matrix[1][6]=2934;      matrix[1][7]=2786;    matrix[1][8]=1771;
//        matrix[2][0]=0; matrix[2][1]=0; matrix[2][2]=0;   matrix[2][3]=1075; matrix[2][4]=671; matrix[2][5]=2684;   matrix[2][6]=2799;     matrix[2][7]=2631;     matrix[2][8]=1616;
//        matrix[3][0]=0; matrix[3][1]=0; matrix[3][2]=0; matrix[3][3]=0;   matrix[3][4]=1329; matrix[3][5]=3273;   matrix[3][6]=3053;     matrix[3][7]=2687;     matrix[3][8]=2037;
//        matrix[4][0]=0f; matrix[4][1]=0; matrix[4][2]=0; matrix[4][3]=0; matrix[4][4]=0;   matrix[4][5]=2013;   matrix[4][6]=2142;     matrix[4][7]=2054;    matrix[4][8]=996;
//        matrix[5][0]=0; matrix[5][1]=0; matrix[5][2]=0; matrix[5][3]=0; matrix[5][4]=0; matrix[5][5]=0;   matrix[5][6]=808;     matrix[5][7]=1131;       matrix[5][8]=1307;
//        matrix[6][0]=0; matrix[6][1]=0; matrix[6][2]=0; matrix[6][3]=0;   matrix[6][4]=0; matrix[6][5]=0;   matrix[6][6]=0;     matrix[6][7]=379;     matrix[6][8]=1235;
//        matrix[7][0]=0f;matrix[7][1]=0; matrix[7][2]=0; matrix[7][3]=0; matrix[7][4]=0;   matrix[7][5]=0;   matrix[7][6]=0;     matrix[7][7]=0;    matrix[7][8]=1059;
//        matrix[8][0]=0; matrix[8][1]=0; matrix[8][2]=0; matrix[8][3]=0; matrix[8][4]=0; matrix[8][5]=0;   matrix[8][6]=0;     matrix[8][7]=0;       matrix[8][8]=0;
        
        
        
       HCL HCE2 = new  HCL(matrix,labels);
       System.out.println(HCE2.get_NewickFormat_HCL());  
    }
    
}
