// Medusa is a graph viewer which allows interactive editing of networks
// (edges and nodes) and also connects to databases.
//
// Copyright (C) 2006 Sean Hooper
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or (at 
// your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
// Public License for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
/*
 * Main.java
 *
 * Created on October 4, 2006, 11:46 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package medusa.stringconnection;

import java.awt.Component;
import medusa.MedusaDataConnection;
import medusa.graph.Graph;
import medusa.graph.Node;

/**
 *
 * @author hooper
 */
public class Main implements MedusaDataConnection{
    
    /** Creates a new instance of Main */
    public Main() {
    }

    /**
     * 
     * @param nodes 
     * @param c 
     * @return 
     */
    public Graph getGraph(String nodes, Component c) {
        
          Graph graph = DataConnection.showDialog(nodes,c, null);
          return graph;
    }
    
    public Graph getGraph(){
        return getGraph(null,null);
    }
    
    
}
