package medusa.georgios.ClusteringAlgorithms;

class MatrixClustering{

   private float[][] A;

   private int m, n;
   
   public MatrixClustering (int m, int n) {
      this.m = m;
      this.n = n;
      A = new float[m][n];
   }


   public MatrixClustering (int m, int n, float s) {
      this.m = m;
      this.n = n;
      A = new float[m][n];
      for (int i = 0; i < m; i++) {
         for (int j = 0; j < n; j++) {
            A[i][j] = s;
         }
      }
   }


   public MatrixClustering copy () {
      MatrixClustering X = new MatrixClustering(m,n);
      float[][] C = X.getArray();
      for (int i = 0; i < m; i++) {
         for (int j = 0; j < n; j++) {
            C[i][j] = A[i][j];
         }
      }
      return X;
   }


   public float[][] getArray () {
      return A;
   }



   public int getRowDimension () {
      return m;
   }



   public int getColumnDimension () {
      return n;
   }


   public float get (int i, int j) {
      return A[i][j];
   }


   public void set (int i, int j, float s) {
      A[i][j] = s;
   }


 

}